#include <pspkernel.h>
#include <pspsdk.h>
#include <pspctrl.h>
#include <pspdisplay.h>
#include <pspsysevent.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "libmenu.h"

#include "thread.h"
#include "common.h"
#include "color.h"
#include "conf.h"

PSP_MODULE_INFO("freestop", PSP_MODULE_KERNEL, 1, 1);

// inipϐ ini̍ڕKv
#define INI_PATH "/freestop.ini"
#define CONF_NUM 2
INI_Key conf[CONF_NUM];

char iniPath[128];

u32 stopkey = 0;
u32 closekey = 0;

enum
{
	NoAction
};

char str[512];
static libmOpt opt;

//vOC X^bNɃACeϐu
MenuContext	Context;
static MenuItem item_list[ITEM_COUNT];

extern int view;

int volume;
int view = 0;
int beforebright;

u32 exitkey = PSP_CTRL_RTRIGGER | PSP_CTRL_START;

//vg^Cv錾
int threadMain(SceSize args, void *argp);
int module_start(SceSize args, void *argp);
int module_stop(SceSize args, void *argp);
void MenuCreate();
int sceDmacplusLcdcSetBaseAddrPatched(void *baseaddr);

int IniLoad(void *argp)
{
	char *temp;

	strcpy(iniPath, argp);
	temp = strrchr(iniPath, '/');
	if( temp != NULL ) *temp = '\0';
	strcat(iniPath, INI_PATH);

	INI_Init_Key(conf);

	INI_Add_Button(conf, "stopkey", &stopkey, PSP_CTRL_RTRIGGER | PSP_CTRL_LTRIGGER | PSP_CTRL_UP );
	INI_Add_Button(conf, "closekey", &closekey , PSP_CTRL_CROSS );

	if(INI_Read_Conf(iniPath, conf) == -1){
		INI_Write_Conf(iniPath, conf, "\r\n");
	}
	
	return 0;
}


void MenuCreate()
{
	//j[ ACe瓮ImۂȂݒɂ
	memset(&opt,0,sizeof(opt));
	opt.type		= LIBM_OPT_LIST;
	opt.list.val	= item_list;
	opt.list.size 	= sizeof(item_list);
	
	libmSetOpt(&Context,&opt);
	
	//j[p̊ePadݒ
		
	//\ HOME
	Context.HotKey.Show				= stopkey;
	//߂ HOME
	Context.HotKey.Back				= closekey;
	//I ~
	Context.HotKey.Select			= PSP_CTRL_NOTE | PSP_CTRL_START | PSP_CTRL_LTRIGGER;
	
	// 
	Context.HotKey.Up				= PSP_CTRL_UP;
	// 
	Context.HotKey.Down				= PSP_CTRL_DOWN;
	// 
	Context.HotKey.Left				= PSP_CTRL_LEFT;
	//E
	Context.HotKey.Right				= PSP_CTRL_RIGHT;
	
	//j[^Cv́uS̕\v
	Context.MenuInfo.Type 			= LIBM_VIEW_ALL;
	//ACeŏ㕔E֗玩Ń^[
	Context.MenuInfo.AutoReturn		= true;
		
	//ANeBuȍڂ̃tHgFAwiF
	Context.Color.Active_Font		= RED;
	Context.Color.Active_Back		= BLACK;
		
	//ANeBuȍڂ̃tHgFAwiF
	Context.Color.Normal_Font		= RED;
	Context.Color.Normal_Back		= BLACK;
		
	//s
	Context.MenuInfo.Lines	= 0;
	
	MenuItem* MAIN = libmAddItem(&Context,NULL,libmCreateSpacer(&opt,""),Invalid,Invalid,NoAction,0);

	//ANeBuACe lݒ
	libmSetActive( &Context ,MAIN);
}

char ms_libmenu_path[] = { "ms0:/seplugins/lib/prxlibmenu.prx"};
char ef_libmenu_path[] = { "ef0:/seplugins/lib/prxlibmenu.prx"};

int LoadStartModule(char *module)
{
	SceUID mod = sceKernelLoadModule(module, 0, NULL);

	if (mod < 0)
		return mod;

	return sceKernelStartModule(mod, strlen(module)+1, module, NULL, NULL);
}

int init(void)
{
	while(1)
	{
		if(sceKernelFindModuleByName("sceKernelLibrary")){
			// prxlibmenu loading Check
			if( sceKernelFindModuleByName("prxlibmenu") == NULL ) {
				// load prxlibmenu
				LoadStartModule(ms_libmenu_path);
				
				if( sceKernelFindModuleByName("prxlibmenu") == NULL ){
					// PSP Go Built-in Memory Support
					LoadStartModule(ef_libmenu_path);
				}
			}

			break;
		}
		
		sceKernelDelayThread(1000);
	}
	return 0;
}


int threadPrint(SceSize args, void *argp){
	while(1){
			printMenu();
		sceKernelDelayThread( 1000 );
	}
return 0;
}

//Main
int threadMain(SceSize args, void *argp)
{			
	IniLoad(argp);
	
	while(1){
		if(
			sceKernelFindModuleByName("sceKernelLibrary") &&
			sceKernelFindModuleByName("sceIOFileManager") &&
			sceKernelFindModuleByName("sceController_Service") &&
			sceKernelFindModuleByName("sceDisplay_Service") &&
			sceKernelFindModuleByName("sceSystemMemoryManager")
		)
			break;

		sceKernelDelayThread(1000000);
	}
	
	sceDisplayGetBrightness(&beforebright,0);
		
	SceCtrlData pad;
	MenuParams* Params;
		
	SceModule2 *mod;
	u32 display;
	
	//[h`FbN
	init();

	//j[쐬
	MenuCreate();
	
	sceCtrlSetSamplingCycle(0);
	sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);
	
	//j[\邽߂
	mod = sceKernelFindModuleByName("sceDisplay_Service");
	if(mod != NULL)
	{
		display = GetSetBaseAddr(mod->text_addr, mod->text_addr + mod->text_size);
		if(display != 0) MAKE_CALL(display, sceDmacplusLcdcSetBaseAddrPatched);
	}
				
	//nȂǂ̏ꍇ
	if(view == 0){
		SceUID print_thid = sceKernelCreateThread("PrintMenu", threadPrint, 1,0x3000, 0, NULL);
		if(threadInfo >= 0)sceKernelStartThread(print_thid, args, argp);
	}

	while( 1 )
	{
	   	sceCtrlPeekBufferPositive(&pad, 1);
		
		//Key͂nāAj[̓𒲂ׂiʂ𓾂j
		Params = libmGetHandle(&Context, &pad);
		if(Params->Action == Menu_Close)
		{	
			Suspend_Resume_Threads(1);
			sceDisplaySetBrightness(beforebright,0);
		}		
		
		//0.001b҂		
		sceKernelDelayThread(1000);
	}
	
	return sceKernelExitDeleteThread( 0 );
}


void printMenu(void)
{		
		
		if(libmInitBuffers(0,PSP_DISPLAY_SETBUF_NEXTFRAME)){	
		if( libmIsOpen(&Context))
		{	
			sceDisplaySetBrightness(45,0);
			libmPrintXY(187,114,BLACK,BLACK,"...............");
			libmPrintXY(187,126,BLACK,BLACK,"...............");
			libmPrintXY(275,120,BLACK,BLACK,"..");
			libmPrintXY(187,120,BLACK,BLACK,"..");
			libmPrintXY(195,120,WHITE,BLACK,"     ~    ");
			libmRender(&Context,140,110,str,256);
			
			SceCtrlData pad;
			sceCtrlPeekBufferPositive(&pad, 1);
			
			if ( (exitkey) && ((pad.Buttons& exitkey) == exitkey) ){
			Suspend_Resume_Threads(1);
			Context.IsOpen = false;
			sceDisplaySetBrightness(beforebright,0);
			sceKernelExitVSHVSH(0);
			}
			
			Suspend_Resume_Threads(0);
			
			sceDisplayWaitVblankStart();
			
			}
		}
	}


int sceDmacplusLcdcSetBaseAddrPatched(void *baseaddr)
{	
	int unk = 0;
	if(view == 0)view= 1;

	// ʏ̎擾
	sceDisplayGetMode(&unk, &canvas.width, &canvas.height);
	sceDisplayGetFrameBuf((void *)&canvas.buffer, &canvas.linewidth, &canvas.pixelformat, 1);

	// VRAM擾
	canvas.buffer = baseaddr;
	
	sceDisplayWaitVblankStart();
		
	return sceDmacplusLcdcSetBaseAddrReal(baseaddr);
}


int module_start(SceSize args, void *argp)
{
	sceDmacplusLcdcSetBaseAddrReal		= (void *)FindProc("sceLowIO_Driver", "sceDmacplus_driver", GetSetBaseAddrNidDisp());

	SceUID main_thid = sceKernelCreateThread("freestop", threadMain, 16,0x3000, 0, NULL);
	if(main_thid >= 0){ 
	sceKernelStartThread(main_thid, args, argp);
	
	u32 orgaddr = FindProc("sceDisplay_Service", "sceDisplay", 0x289D82FE);
	sceDisplaySetFrameBuf_Real = (void *)orgaddr;
	}
	
	Get_FirstThreads();

    return 0;
}


int module_stop(SceSize args, void *argp)
{
    return 0;
}

